// very simple INA219 class - uses standard Arduino Wire library.  ceptimus  August 2018
#ifndef INA219_h
#define INA219_h

// only valid choices for INA219_BUS_VOLTAGE_RANGE are 16 (for 16V range with 4 mV accuracy) or 32 (for 32V range with 8 mV accuracy)

// the following shunt voltage ranges are possible, with the table indicating the nominal current range and resolution with the default R100 (0.1 ohm) shunt resistor
//  range (mV)  max current (mA)  resolution (mA)
//   +/-  40       +/-  400           0.1
//   +/-  80       +/-  800           0.2
//   +/- 160       +/- 1600           0.4
//   +/- 320       +/- 3200           0.8
// only valid choices for SHUNT_VOLTAGE_RANGE are 40, 80, 160, or 320.

class INA219 {
  public:
  	INA219(const uint8_t address, const uint8_t busVoltageRange, const uint16_t shuntVoltageRange, const float shuntResistance); // constructor;
    void start(void);
    float busVoltage_V(void);
  	float current_mA(void);
  private:
    uint8_t i2cAddr;
    uint16_t ina219config;
    float currentMultiplier;
  	void writeReg(uint8_t addr, uint16_t value);
  	uint16_t readReg(uint8_t addr);
};

#endif
